using System;
using System.Collections.Generic;
using System.IO;

namespace BrainFuckThatDuck
{
	public class Prekladac
	{
		public static string TITULEK = "BrainFuckThatDuck";
		public static bool DEBUGMODE = false;
		public string CESTA = "";
		
		public Dictionary<int, int> bunky; // Potřeba indexu se záporným číslem, to je důvod, proč list nestačí
		public List<int> presmerovani;
		public int bunka, pocet, preskocit;

		private string kod;

		public Prekladac ()
		{
			Spustit();
		}

		public void Spustit(){
			Console.Clear(); // Vymaže konzoli (v případě, že to jde od znova)
			NajdiCestu();
			Nacti();
			Precti();
		}

		public void NajdiCestu(){

			DirectoryInfo slozka = new DirectoryInfo(Directory.GetCurrentDirectory());
			FileInfo[] soubory = slozka.GetFiles("*.txt");
			Console.WriteLine("Vyber si jeden z txt souborů u tohoto programu:\n");
			for(int i = 0; i < soubory.Length; i++){
				Console.WriteLine(i + " => " + soubory[i].Name);
			}
			Console.WriteLine("");
			while (true) {
				try{
					Console.Write("Napiš číslo souboru [0-"+(soubory.Length-1)+"]: ");
					int index = int.Parse(Console.ReadLine());
					if(index>=0 && index<soubory.Length){
						CESTA = soubory[index].Name;
						break;
					}else continue;
				}catch(Exception e){}
			}
			Console.Clear();
		}

		public void Nacti(){
			//Přečte si kód ze souboru kod.txt, který je přiložený k tomuto exečku
			StreamReader zdroj = new StreamReader(CESTA);
			kod = "";
			string line = "";
			while((line=zdroj.ReadLine())!=null){
				kod+=line;
			}
			zdroj.Close ();
			
			// Nejdřiv zkontoluj, jestli má správný poměr hranatých závorek (jinak to ani nespustí -> dělalo by to neplechu)
			int levyZavorky = 0, pravyZavorky = 0;
			foreach (char c in kod) {
				if (c == '[')
					levyZavorky++;
				if (c == ']')
					pravyZavorky++;
			}
			if (levyZavorky != pravyZavorky) {
				Console.Write("Nemůžeš použít kód, kde je rozdílný počet hranatých závorek.\n(Někde máš chybu ve smyčkách.)");
				Konec();
				return;
			}

			//Initializuje
			bunky = new Dictionary<int, int>();
			presmerovani = new List<int>();
			bunka = 0;
			pocet = 0;
			preskocit = 0;
			PosunBunku(0);
			Console.Title = TITULEK;
		}

		public void Precti(){
			for(int i = 0; i < kod.Length; i++){
				char znak = kod[i]; // Znaky, které přečte: > < + - . , [ ]
				if (preskocit!=0) {
					if (znak == '[') preskocit++; // Další smyčka
					if(znak==']') preskocit--; // Pokud už je konec, tak to zruší přeskakování
					continue;
				}
				if(znak=='>'){
					PosunBunku(1);
					Debug(i, znak, "array pos. now " + bunka);
				}else if(znak=='<'){
					PosunBunku(-1);
					Debug(i, znak, "array pos. now " + bunka);
				}else if(znak=='+'){
					PrictiHodnotu(1);
					Debug(i, znak, "a["+bunka+"]= " + BunkaHodnota());
				}else if(znak=='-'){
					PrictiHodnotu(-1);
					Debug(i, znak, "a["+bunka+"]= " + BunkaHodnota());
				}else if(znak=='.'){
					VypisHodnotu(i, znak);
				}else if(znak==','){
					PrectiHodnotu(i, znak);
				}else if(znak=='['){
					ZacatekSmycky(i, znak);
				}else if(znak==']'){
					int j = KonecSmycky(i, znak); // Na konci smyčky zjistí, kolik má aktualní buňka číslo
					if (j != -1) i = j; // Pokud to je 0, tak jde dál
				}
				pocet++; // Počet provedených kroků
			}

			Konec(); // Pokud to vše přečtě, tak to vypíše konec
		}

		public void Konec(){
			Console.WriteLine("\nKonec programu. Kód byl přeložen ve " + pocet + " krocích.");
			Console.Write("Chcete zkusit nějaký další kód? [Y/n]: ");
			char znak = Console.ReadKey().KeyChar;
			if (znak == 'y' || znak == 'Y') Spustit(); // A jede se od znova
			// Pokud jsme se dostali až sem, tak už je konec :(
			Console.WriteLine("\nNashle!");
			Console.ReadKey();
		}

		public int BunkaHodnota(){
			return bunky[bunka];
		}

		public void PosunBunku(int hodnota){ // > <
			bunka+=hodnota;
			if(!bunky.ContainsKey(bunka)){
				bunky.Add(bunka, 0);
			}
		}

		public void PrictiHodnotu(int hodnota){ // + -
			bunky[bunka] += hodnota;
		}

		public void VypisHodnotu(int i, char znak){ // .
			char novyZnak = (char)(BunkaHodnota ());
			if(!DEBUGMODE)
				Console.Write(novyZnak);
			else	
				Debug (i, znak, "output '" + (int)novyZnak + "' " + novyZnak); // Pokud je debug mód, vypíše tohle místo normálního znaku
		}

		public void PrectiHodnotu(int i, char znak){ // ,
			Console.Title = "Stiskni nejakou klavesu";
			int hodnota = (int)(Console.ReadKey ().KeyChar);
			if(DEBUGMODE) Console.WriteLine(""); // Vytvoří další řádek, aby napsaný znak byl přehledně vidět, když je debugging
			Debug (i, znak, "read in " + (char)(hodnota) + " (" + hodnota + ")");
			if (hodnota == 0) Console.WriteLine(""); // Když zmáčkne backspace, tak hodí novej řádek
			if (hodnota == 10) hodnota = 0; // Pokuď je hodnota Enter, tak to skočí na nulu jako prázdná hodnota
			NastavHodnotu(hodnota);
			Console.Title = TITULEK;
		}

		public void ZacatekSmycky(int i, char znak){ // [
			if (BunkaHodnota () == 0) {
				preskocit++;
				Debug(i, znak, "Not entering a loop but skipping.");
				return;
			}
			Debug(i, znak, "Array["+bunka+"] is '"+BunkaHodnota()+"' ** Loop nesting level: "+presmerovani.Count+".");
			presmerovani.Add(i);
		}

		public int KonecSmycky(int i, char znak){ // ]
			Debug(i, znak, "Array["+bunka+"] is '"+BunkaHodnota()+"'");
			if(BunkaHodnota()!=0){
				return Posledni(presmerovani);
			}else{
				SmazPosledni (presmerovani);
			}
			return -1;
		}

		public void NastavHodnotu(int hodnota){
			bunky[bunka] = hodnota;
		}

		public int Posledni(List<int> list){
			if(list.Count-1<0)
				Debug (-1, ']', "Objevila se chyba u smyčky.");
			else
				return list[list.Count-1];
			return 0;
		}

		public bool SmazPosledni(List<int> list){
			if (list.Count == 0)
				return false;
			list.RemoveAt(list.Count-1);
			return true;
		}

		public void Debug(int i, char znak, string text){
			if (DEBUGMODE){// || znak=='<' || znak=='>') { // Když je debugging, tak je true, jinak false
				Console.WriteLine(pocet + " (" + i + "): " + znak + " | " + text);
			}
		}
	}
}

