#include "brainfuck.h"

uint8_t brainFck::run(char *program, char *input, vector<char> &output, uint32_t &outLen){
	uint32_t i;

	this->program=program;
	this->input=input;
	output.clear();
	inLen = strlen(input)+1;
	PSarr=0;
	PSout=0;
	PSin=0;

	for(i=0;i<ARRAY;++i)array[i]=0;

	uint8_t res = interpret(0, output, 1);
	outLen = PSout;
	return res;
}
uint8_t brainFck::interpret(uint32_t pos, vector<char> &output, bool first){
	uint8_t err;

	while(program[pos]){
		switch(program[pos]){
			case '+':
				array[PSarr]++;
				break;
			case '-':
				array[PSarr]--;
				break;
			case '>':
				PSarr++;
				if(PSarr>=ARRAY)PSarr-=ARRAY;
				break;
			case '<':
				PSarr--;
				if(PSarr<0)PSarr+=ARRAY;
				break;
			case ',':
				if(PSin<inLen)
					array[PSarr]=input[PSin++];
				else
					array[PSarr]=0;
				break;
			case '.':
				output.push_back(array[PSarr]);
				PSout++;
				break;
			case '[':
				if(!array[PSarr]){
					if(skipLoop(pos))return 2;
				}else{
					if(err=interpret(pos+1, output))return err;
					continue;
				}
				break;
			case ']':
				return first;
			case '#':
				printf("programPos:%d, pointer:%d value in pointer:%d actInput:%d, actOutput:%d\n", pos, PSarr, array[PSarr],PSin,PSout);
				break;
		}
		++pos;
	}
	return !first;
}

uint8_t brainFck::skipLoop(uint32_t &actPos){
	uint32_t loops=1;
	while(program[++actPos]){
		if(program[actPos]=='[')loops++;
		else if(program[actPos]==']')loops--;
		if(!loops)return 0;
	}
	return 1;
}
