#include "common.h"
#include "brainfuck.h"

int main(int argc, char **argv){
	uint32_t outLen,i;
	uint8_t err;
	char temp;

	vector<char> output;
	vector<char> input;
	vector<char> program;

	FILE *prog, *inF, *outF; 

	if(argc!=4){
		if(argc<4)fputs("Too few arguments!\n", stderr);
		else if(argc>4)fputs("Too much arguments!\n", stderr);
		return 1;
	}
	if(!(prog=fopen(argv[1],"r"))){
		fputs("Program file not found!\n", stderr);
		return 1;
	}
	if(!(inF=fopen(argv[2],"r"))){
		fputs("Input file not found!\n", stderr);
		return 1;
	}
	if(!(outF=fopen(argv[3],"w"))){
		fputs("Output file not found!\n", stderr);
		return 1;
	}

	while((temp=fgetc(prog))!=EOF)
			program.push_back(temp);
	while((temp=fgetc(inF))!=EOF)
			input.push_back(temp);
		
	program.push_back(0);
	input.push_back(0);

	brainFck *interpreter = new brainFck();


	if(err=interpreter->run(&program[0], &input[0], output, outLen))printf("error? %d\n", err);

	output.push_back(0);

	for(i=0;i<output.size();++i)fputc(output[i],outF);

	fclose(prog);
	fclose(inF);
	fclose(outF);

	return 0;
}
